"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _CloudUpload = _interopRequireDefault(require("@material-ui/icons/CloudUpload"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Dropzone = /*#__PURE__*/function (_Component) {
  _inherits(Dropzone, _Component);

  var _super = _createSuper(Dropzone);

  function Dropzone(props) {
    var _this;

    _classCallCheck(this, Dropzone);

    _this = _super.call(this, props);
    _this.state = {
      hightlight: false
    };
    _this.fileInputRef = /*#__PURE__*/_react["default"].createRef();
    _this.openFileDialog = _this.openFileDialog.bind(_assertThisInitialized(_this));
    _this.onFilesAdded = _this.onFilesAdded.bind(_assertThisInitialized(_this));
    _this.onDragOver = _this.onDragOver.bind(_assertThisInitialized(_this));
    _this.onDragLeave = _this.onDragLeave.bind(_assertThisInitialized(_this));
    _this.onDrop = _this.onDrop.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Dropzone, [{
    key: "openFileDialog",
    value: function openFileDialog() {
      if (this.props.disabled) return;
      this.fileInputRef.current.click();
    }
  }, {
    key: "onFilesAdded",
    value: function onFilesAdded(evt) {
      if (this.props.disabled) return;
      var files = evt.target.files;

      if (this.props.onFilesAdded) {
        var array = this.fileListToArray(files);
        this.props.onFilesAdded(array);
        this.fileInputRef.current.value = "";
      }
    }
  }, {
    key: "onDragOver",
    value: function onDragOver(event) {
      event.preventDefault();
      if (this.props.disabed) return;
      this.setState({
        hightlight: true
      });
    }
  }, {
    key: "onDragLeave",
    value: function onDragLeave(event) {
      this.setState({
        hightlight: false
      });
    }
  }, {
    key: "onDrop",
    value: function onDrop(event) {
      event.preventDefault();
      if (this.props.disabed) return;
      var files = event.dataTransfer.files;

      if (this.props.onFilesAdded) {
        var array = this.fileListToArray(files);
        this.props.onFilesAdded(array);
      }

      this.setState({
        hightlight: false
      });
    }
  }, {
    key: "fileListToArray",
    value: function fileListToArray(list) {
      var array = [];

      for (var i = 0; i < list.length; i++) {
        array.push({
          data: list.item(i),
          status: "unLoaded"
        });
      }

      return array;
    }
  }, {
    key: "render",
    value: function render() {
      var dropzoneDivStyle = {
        height: "150px",
        width: "150px",
        "background-color": "#fff",
        border: "2px dashed rgb(187, 186, 186)",
        "border-radius": "50%",
        display: "flex",
        "align-items": "center",
        "justify-content": "center",
        "flex-direction": "column",
        "font-size": "16px" // "margin-left": "24px",
        // "margin-top": "12px",

      };

      if (this.state.hightlight) {
        dropzoneDivStyle["background-color"] = "rgb(188, 185, 236)";
      }

      if (this.props.disabled) {
        dropzoneDivStyle["cursor"] = "default";
      } else {
        dropzoneDivStyle["cursor"] = "pointer";
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        style: dropzoneDivStyle,
        onDragOver: this.onDragOver,
        onDragLeave: this.onDragLeave,
        onDrop: this.onDrop,
        onClick: this.openFileDialog
      }, /*#__PURE__*/_react["default"].createElement("input", {
        ref: this.fileInputRef,
        style: {
          display: "none"
        },
        type: "file",
        multiple: true,
        onChange: this.onFilesAdded
      }), /*#__PURE__*/_react["default"].createElement(_CloudUpload["default"], null), /*#__PURE__*/_react["default"].createElement("span", null, "Dosya Y\xFCkle"));
    }
  }]);

  return Dropzone;
}(_react.Component);

var _default = Dropzone;
exports["default"] = _default;