"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactIntl = require("react-intl");

var _Upload = _interopRequireDefault(require("./Upload"));

var _DialogComponent = _interopRequireDefault(require("./DialogComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FileUpload = /*#__PURE__*/function (_React$Component) {
  _inherits(FileUpload, _React$Component);

  var _super = _createSuper(FileUpload);

  function FileUpload(props) {
    var _this;

    _classCallCheck(this, FileUpload);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "fileInfoArray", null);

    _defineProperty(_assertThisInitialized(_this), "addProperty", function (fieldName, fieldValue) {
      return {
        fieldName: fieldName,
        fieldValue: fieldValue.toString()
      };
    });

    _defineProperty(_assertThisInitialized(_this), "properties", []);

    if (!props.fieldName || !props.fieldValue || !props.fileInfo || !props.fileTypes) {
      throw new Error("At FileUpload.js: fileTypes, fieldName, fieldValue or fileInfo cannot be undefined or null.");
    }

    _this.fileInfoArray = props.fileInfo;
    _this.fieldName = props.fieldName;
    _this.fieldValue = props.fieldValue;
    _this.fileInfo = props.fileInfo;
    _this.fileTypes = props.fileTypes;
    _this.dialogProps = {
      fullWidth: props.fullWidth !== false,
      maxWidth: props.maxWidth ? props.maxWidth : "md",
      height: "450px",
      buttonVariant: props.buttonVariant ? props.buttonVariant : "contained",
      buttonColor: props.buttonColor ? props.buttonColor : "primary",
      btnUniqueName: props.btnUniqueName ? props.btnUniqueName : props.fieldName,
      buttonText: props.buttonText ? props.buttonText : "Dosya Yükle",
      closeButtonText: props.closeButtonText ? props.closeButtonText : "İptal",
      dialogTitle: props.dialogTitle ? props.dialogTitle : ""
    };
    return _this;
  }

  _createClass(FileUpload, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      this.fileInfoArray.forEach(function (f) {
        return _this2.properties.push(_this2.addProperty(f["fieldName"], f["fieldValue"]));
      });
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_DialogComponent["default"], {
        dialogProps: this.dialogProps
      }, /*#__PURE__*/_react["default"].createElement(_Upload["default"], {
        fieldName: this.fieldName,
        fieldValue: this.fieldValue,
        fileInfo: this.properties,
        fileTypes: this.fileTypes
      })));
    }
  }]);

  return FileUpload;
}(_react["default"].Component);

var _default = (0, _reactIntl.injectIntl)(FileUpload);

exports["default"] = _default;