"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Dropzone = _interopRequireDefault(require("./Dropzone"));

var _muiDatatables = _interopRequireDefault(require("mui-datatables"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _CheckCircle = _interopRequireDefault(require("@material-ui/icons/CheckCircle"));

var _Error = _interopRequireDefault(require("@material-ui/icons/Error"));

var _Cancel = _interopRequireDefault(require("@material-ui/icons/Cancel"));

var _ReplayRounded = _interopRequireDefault(require("@material-ui/icons/ReplayRounded"));

var _axios = _interopRequireDefault(require("./axios"));

var _Publish = _interopRequireDefault(require("@material-ui/icons/Publish"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _DeleteSweep = _interopRequireDefault(require("@material-ui/icons/DeleteSweep"));

var _core = require("@material-ui/core");

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _reactToastify = require("react-toastify");

var _reactIntl = require("react-intl");

var _inlineScan = _interopRequireDefault(require("inline-scan"));

var _styles = require("@material-ui/core/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Upload = /*#__PURE__*/function (_Component) {
  _inherits(Upload, _Component);

  var _super = _createSuper(Upload);

  function Upload(props) {
    var _this;

    _classCallCheck(this, Upload);

    _this = _super.call(this, props);
    _this.state = {
      files: [],
      uploading: false,
      uploadProgress: {},
      successfullUploaded: false,
      scanCount: 0
    };

    if (!props.fileTypes) {
      throw new Error("At Upload.js: fileTypes cannot be empty.");
    }

    _this.fileTypes = props.fileTypes;
    _this.handleSelectChange = _this.handleSelectChange.bind(_assertThisInitialized(_this));
    _this.getFilesFromServer = _this.getFilesFromServer.bind(_assertThisInitialized(_this));
    _this.onFilesAdded = _this.onFilesAdded.bind(_assertThisInitialized(_this));
    _this.sendRequest = _this.sendRequest.bind(_assertThisInitialized(_this));
    _this.sendDeleteRequest = _this.sendDeleteRequest.bind(_assertThisInitialized(_this));
    _this.sendDeleteAllRequest = _this.sendDeleteAllRequest.bind(_assertThisInitialized(_this));
    _this.clearAll = _this.clearAll.bind(_assertThisInitialized(_this));
    _this.renderFileRowFileName = _this.renderFileRowFileName.bind(_assertThisInitialized(_this));
    _this.renderFileRowDocType = _this.renderFileRowDocType.bind(_assertThisInitialized(_this)); // this.renderHepsiniSil = this.renderHepsiniSil.bind(this);

    _this.handleScan = _this.handleScan.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Upload, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getFilesFromServer();
    }
  }, {
    key: "getFilesFromServer",
    value: function getFilesFromServer() {
      var _this2 = this;

      _axios["default"].get(process.env.REACT_APP_FILE_SERVICE_HOST + "/api/v1/filehandler/" + this.props.fieldName + "/" + this.props.fieldValue).then(function (res) {
        var files = [];
        var copy = {};
        res.data.forEach(function (item) {
          files.push({
            data: {
              data: null,
              name: item.fileName,
              id: item.fileId,
              documentType: item.documentType
            },
            status: "loaded"
          });
          copy[item.fileName] = {
            state: "done",
            percentage: 100
          };
        });

        _this2.setState({
          files: files,
          uploadProgress: copy
        });
      });
    }
  }, {
    key: "onFilesAdded",
    value: function onFilesAdded(files) {
      var _this3 = this;

      var newFiles = [];
      files.forEach(function (file) {
        if (_this3.state.files.find(function (x) {
          return x.data.name == file.data.name;
        }) == undefined) {
          newFiles.push({
            data: {
              data: file.data,
              name: file.data.name,
              id: 0,
              documentType: ""
            },
            status: "unLoaded"
          });
        }
      });
      this.setState(function (prevState) {
        return {
          files: prevState.files.concat(newFiles),
          uploadProgress: {}
        };
      });
    }
  }, {
    key: "sendRequest",
    value: function sendRequest(file) {
      var _this4 = this;

      var formData = new FormData();
      formData.append("file", file.data.data, file.data.name);
      formData.append("fileinfo", JSON.stringify(this.props.fileInfo));
      formData.append("username", localStorage.getItem("user_name"));
      formData.append("userid", localStorage.getItem("user_id"));
      formData.append("documenttype", file.data.documentType);

      _axios["default"].post("/dosyaerisim/upload", formData).then(function (res) {
        var copy = _objectSpread({}, _this4.state.uploadProgress);

        copy[file.data.name] = {
          state: "done",
          percentage: 100
        };

        var index = _this4.state.files.findIndex(function (f) {
          return f.data.name == file.data.name;
        });

        var newFiles = _toConsumableArray(_this4.state.files);

        newFiles[index].status = "loaded";
        newFiles[index].data.id = res.data.fileId;

        _this4.setState({
          uploadProgress: copy,
          files: newFiles
        });
      })["catch"](function () {
        var index = _this4.state.files.findIndex(function (f) {
          return f.data.name == file.data.name;
        });

        var newFiles = _toConsumableArray(_this4.state.files);

        newFiles[index].status = "error";

        var copy = _objectSpread({}, _this4.state.uploadProgress);

        copy[file.data.name] = {
          state: "error",
          percentage: 0
        };

        _this4.setState({
          uploadProgress: copy,
          files: newFiles
        });

        _reactToastify.toast.error(_this4.props.intl.formatMessage({
          id: "INSERT_FAILED"
        }));
      });

      return {
        success: true
      };
    }
  }, {
    key: "sendDeleteRequest",
    value: function sendDeleteRequest(file) {
      var _this5 = this;

      _axios["default"].post("/dosyaerisim/delete_by?uid=" + file.id).then(function () {
        _this5.getFilesFromServer();
      })["catch"](function () {
        _reactToastify.toast.error(_this5.props.intl.formatMessage({
          id: "RECORD_NOT_FOUND"
        }));
      });
    }
  }, {
    key: "sendDeleteAllRequest",
    value: function sendDeleteAllRequest(file) {
      var _this6 = this;

      _axios["default"].post("/dosyaerisim/delete_by?uid=" + file.id).then(function () {})["catch"](function () {
        _reactToastify.toast.error(_this6.props.intl.formatMessage({
          id: "DELETE_FAILED"
        }));
      });
    }
  }, {
    key: "onDeleteButtonClick",
    value: function onDeleteButtonClick(file) {
      this.sendDeleteRequest(file.data);
    }
  }, {
    key: "onCancelButtonClick",
    value: function onCancelButtonClick(file) {
      var index = this.state.files.findIndex(function (f) {
        return f.data.name == file.name;
      });

      var newFiles = _toConsumableArray(this.state.files);

      newFiles.splice(index, 1);

      var copy = _objectSpread({}, this.state.uploadProgress);

      delete copy[file.name];
      this.setState({
        uploadProgress: copy,
        files: newFiles
      });
    }
  }, {
    key: "handleSelectChange",
    value: function handleSelectChange(event, file) {
      var index = this.state.files.findIndex(function (f) {
        return f.data.name == file.data.name;
      });

      var newFiles = _toConsumableArray(this.state.files);

      newFiles[index].data.documentType = event.target.value;
      this.setState({
        files: newFiles
      });
    }
  }, {
    key: "clearAll",
    value: function () {
      var _clearAll = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _this7 = this;

        var promises;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                promises = [];
                this.state.files.forEach(function (file) {
                  promises.push(_this7.sendDeleteAllRequest(file.data));
                });
                _context.next = 4;
                return Promise.all(promises).then(function () {
                  setTimeout(_this7.getFilesFromServer, 1000);
                })["catch"](function () {
                  _reactToastify.toast.error(_this7.props.intl.formatMessage({
                    id: "UNEXPECTED_ERROR"
                  }));
                });

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function clearAll() {
        return _clearAll.apply(this, arguments);
      }

      return clearAll;
    }()
  }, {
    key: "renderFileRowFileName",
    value: function renderFileRowFileName(fileName) {
      return /*#__PURE__*/_react["default"].createElement(_core.Typography, {
        variant: "subtitle1",
        component: "subtitle1"
      }, fileName);
    }
  }, {
    key: "renderFileRowFileActions",
    value: function renderFileRowFileActions(file) {
      var _this8 = this;

      return /*#__PURE__*/_react["default"].createElement("div", null, file && file.status === "unLoaded" && /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
        title: "Y\xFCkle"
      }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        "aria-label": "Upload",
        onClick: function onClick() {
          return _this8.sendRequest(file);
        }
      }, /*#__PURE__*/_react["default"].createElement(_Publish["default"], null))), file && file.status === "loaded" && /*#__PURE__*/_react["default"].createElement(_CheckCircle["default"], null), file && file.status == "loaded" && /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
        title: "Sil"
      }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        "aria-label": "Delete",
        onClick: function onClick() {
          return _this8.onDeleteButtonClick(file);
        }
      }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], null))), file && file.status === "error" && /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
        title: "Tekrar G\xF6nder"
      }, /*#__PURE__*/_react["default"].createElement(_ReplayRounded["default"], {
        "aria-label": "ReSend",
        onClick: function onClick() {
          return _this8.sendRequest(file);
        }
      }, /*#__PURE__*/_react["default"].createElement(_Cancel["default"], null))), file && file.status === "error" && /*#__PURE__*/_react["default"].createElement(_Error["default"], null), file && file.status == "error" && /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
        title: "Kald\u0131r"
      }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        "aria-label": "Cancel",
        onClick: function onClick() {
          return _this8.onCancelButtonClick(file);
        }
      }, /*#__PURE__*/_react["default"].createElement(_Cancel["default"], null))));
    }
  }, {
    key: "renderFileRowDocType",
    value: function renderFileRowDocType(file) {
      var _this9 = this;

      var textFieldStyle = {
        width: 200,
        marginTop: "1%"
      };
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_core.TextField, {
        select: file && file.status === "unLoaded",
        size: "small",
        margin: "normal",
        name: "documentType",
        value: file.data.documentType,
        onChange: function onChange(event) {
          return _this9.handleSelectChange(event, file);
        },
        style: textFieldStyle,
        InputProps: {
          readOnly: file.status != "unLoaded"
        }
      }, /*#__PURE__*/_react["default"].createElement(_core.MenuItem, {
        value: ""
      }, /*#__PURE__*/_react["default"].createElement("em", null)), this.fileTypes.map(function (fileType) {
        return /*#__PURE__*/_react["default"].createElement(_core.MenuItem, {
          value: fileType
        }, fileType);
      })));
    } // renderHepsiniSil() {
    //   if (this.state.files.filter((f) => f.status == "loaded").length > 0) {
    //     return (
    //       <Button
    //         onClick={this.clearAll}
    //         color="secondary"
    //         startIcon={<DeleteSweepIcon />}
    //       >
    //         Hepsini Sil
    //       </Button>
    //     );
    //   }
    // }

  }, {
    key: "handleScan",
    value: function handleScan(obj) {
      var scanCounter = this.state.scanCount + 1;
      var scanName = "Tarama ";

      if (scanCounter < 10) {
        scanName += "0";
      }

      scanName += scanCounter;
      scanName += ".jpg";
      this.setState({
        scanCount: scanCounter
      });
      var file = {
        data: {
          data: obj,
          name: scanName,
          id: 0,
          documentType: ""
        },
        status: "unLoaded"
      };
      var index = this.state.files.length;

      var newFiles = _toConsumableArray(this.state.files);

      newFiles[index] = file;
      this.setState({
        files: newFiles
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this10 = this;

      var muiDataTableColumns = [{
        name: "Dosya Adı",
        options: {
          display: true,
          customHeadRender: function customHeadRender(_ref) {
            var index = _ref.index,
                column = _objectWithoutProperties(_ref, ["index"]);

            return /*#__PURE__*/_react["default"].createElement(_core.TableCell, {
              style: {
                width: "45%"
              },
              key: index
            }, column.name);
          }
        }
      }, {
        name: "Döküman Tipi",
        options: {
          display: true,
          customHeadRender: function customHeadRender(_ref2) {
            var index = _ref2.index,
                column = _objectWithoutProperties(_ref2, ["index"]);

            return /*#__PURE__*/_react["default"].createElement(_core.TableCell, {
              style: {
                width: "35%"
              },
              key: index,
              align: "center"
            }, column.name);
          }
        }
      }, {
        name: "     ",
        options: {
          display: true,
          customHeadRender: function customHeadRender(_ref3) {
            var index = _ref3.index,
                column = _objectWithoutProperties(_ref3, ["index"]);

            return /*#__PURE__*/_react["default"].createElement(_core.TableCell, {
              style: {
                width: "20%"
              },
              key: index
            }, column.name);
          }
        }
      }, {
        name: "file",
        options: {
          display: false
        }
      }];
      var muiDataTableData = [];
      this.state.files.forEach(function (file) {
        var fileData = [file.data.name, file.documentType, file];
        muiDataTableData.push(fileData);
      });
      var optionsDataTable = {
        selectableRows: false,
        pagination: false,
        stickyHeader: true,
        textLabels: {
          body: {
            noMatch: "Sorry, no matching records found",
            toolTip: "Sort",
            columnHeaderTooltip: function columnHeaderTooltip(column) {
              return "Sort for ".concat(column.label);
            }
          },
          pagination: {
            next: "Next Page",
            previous: "Previous Page",
            rowsPerPage: "Rows per page:",
            displayRows: "of"
          },
          toolbar: {
            search: "Search",
            downloadCsv: "Download CSV",
            print: "Print",
            viewColumns: "View Columns",
            filterTable: "Filter Table"
          },
          filter: {
            all: "All",
            title: "FILTERS",
            reset: "RESET"
          },
          viewColumns: {
            title: "Show Columns",
            titleAria: "Show/Hide Table Columns"
          },
          selectedRows: {
            text: "row(s) selected",
            "delete": "Delete",
            deleteAria: "Delete Selected Rows"
          }
        },
        customRowRender: function customRowRender(fileData, dataIndex, rowIndex) {
          return /*#__PURE__*/_react["default"].createElement(_core.TableRow, {
            key: rowIndex + "_" + dataIndex
          }, /*#__PURE__*/_react["default"].createElement(_core.TableCell, {
            style: {
              width: "45%"
            }
          }, _this10.renderFileRowFileName(fileData[0])), /*#__PURE__*/_react["default"].createElement(_core.TableCell, {
            style: {
              width: "35%"
            }
          }, _this10.renderFileRowDocType(fileData[2])), /*#__PURE__*/_react["default"].createElement(_core.TableCell, {
            style: {
              width: "20%"
            },
            align: "right"
          }, _this10.renderFileRowFileActions(fileData[2])));
        },
        customToolbar: function customToolbar() {
          return /*#__PURE__*/_react["default"].createElement(_inlineScan["default"], {
            outerFunction: _this10.handleScan,
            icon: true
          });
        }
      };
      var uploadStyle = {
        display: "flex",
        "flex-direction": "column",
        flex: "1",
        "align-items": "flex-start",
        "text-align": "left",
        overflow: "hidden"
      };
      var contentStyle = {
        display: "flex",
        "flex-direction": "row",
        "padding-top": "12px",
        "box-sizing": "border-box",
        width: "100%"
      };
      var dropzoneContainerStyle = {
        "padding-top": "2%"
      };
      var filesStyle = {
        "margin-left": "12px",
        "align-items": "flex-start",
        "justify-items": "flex-start",
        flex: "1",
        "overflow-y": "auto"
      }; // var styleActions = {
      //   display: "flex",
      //   flex: "1",
      //   width: "100%",
      //   "align-items": "flex-end",
      //   "flex-direction": "column",
      //   padding: "12px",
      // };
      // var scanningDivStye = {
      //   padding: "10% 50px",
      // };

      return /*#__PURE__*/_react["default"].createElement("div", {
        style: uploadStyle
      }, /*#__PURE__*/_react["default"].createElement("div", {
        style: contentStyle
      }, /*#__PURE__*/_react["default"].createElement("div", {
        style: dropzoneContainerStyle
      }, /*#__PURE__*/_react["default"].createElement("div", {
        "class": "container"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        "class": "row"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        "class": "col justify-content-center"
      }, /*#__PURE__*/_react["default"].createElement(_Dropzone["default"], {
        onFilesAdded: this.onFilesAdded,
        disabled: this.state.uploading
      }))))), /*#__PURE__*/_react["default"].createElement("div", {
        style: filesStyle
      }, /*#__PURE__*/_react["default"].createElement(_muiDatatables["default"], {
        title: "Dosyalar",
        data: muiDataTableData,
        columns: muiDataTableColumns,
        options: optionsDataTable
      }))));
    }
  }]);

  return Upload;
}(_react.Component);

var _default = (0, _reactIntl.injectIntl)(Upload);

exports["default"] = _default;